//RemplPolices_fichier_305f.js
// 11.11.14 / Hans Hsler, Chtelard 52, CH-1018 Lausanne / E-mail: hsa@ringier.ch
//DESCRIPTION:Remplacer les polices du document actif.

// activer l'affichage des dialogues
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// vrifier la version du programme
var appVers = app.version[0];
if (appVers != 5) {
	alert ("Il ne faut utiliser ce script qu'avec InDesign CS3.", "Stop");
	exit();
}

var oneDoc = true;
var selFolder = Folder ("Tiger/Users/Documents/");

// vrifier s'il y a un document ouvert
if (app.documents.length == 0) {
	oneDoc = false;
	// montrer le dialogue pour slectionner un dossier
	var sourceFolder = Folder.selectDialog("Slectionner le dossier contenant les fichiers InDesign", selFolder);
	if (sourceFolder != null) {
		// essayer de trouver le fichier texte
		var fileList = Folder(sourceFolder).getFiles("*.txt");
		if (fileList.length == 0) {
			alert ("Le dossier ne contient pas de fichier texte.", "Un problme");
			exit();
		}
		var f = fileList[0];
	}
	else {
		exit();
	}
}
else {
// demander  l'utilisateur de slectionner un fichier
	var f = File(selFolder).openDlg("Slectionner le fichier contenant les noms des polices", "Text Files:*.txt");
	if (f == null) {
		exit();
	}
}

// tenter de lire le fichier
var fontsString = "";
var fileIsOpen = f.open("r");
if (fileIsOpen) {
	try {
		fontsString = f.read();
		f.close();
	}
	catch (e) {
		try {
			f.close();
		}
		catch (e) {
		}
	}
}

// tester les caractres sparateur 
var nameSep = "";
var paraSep = "";
var pairSep = "";
if (fontsString.indexOf("\t") != -1) {
	nameSep = "tab";
}
if (fontsString.indexOf("\r\n") != -1) {
	paraSep = "\r\n";
}
else if (fontsString.indexOf("\r") != -1) {
	paraSep = "\r";
}
else if (fontsString.indexOf("\n") != -1) {
	paraSep = "\n";
}
if (fontsString.indexOf("=") != -1) {
	pairSep = "=";
}
if (nameSep == "") {
	alert ("Le fichier slectionn ne contient pas de tabulateur\n(entre famille et style).", "Stop");
	exit();
}
if (pairSep == "") {
	alert ("Le fichier slectionn ne contient pas de signe gal\n(entre anciens et nouveaux noms).", "Stop");
	exit();
}
if (paraSep == "") {
	alert ("Le fichier slectionn\nne contient pas de signes retour.", "Stop");
	exit();
}

// convertir la chane de texte des noms de polices en liste
try {
	fontsList = fontsString.split(paraSep);
}
catch (e) {
}

// appeler la fonction quand il y a un document ouvert
var probCtr = 0;
if (oneDoc) {
	replaceFonts();
}
// sinon, lister les documents InDesign et les trater  tour de rle
else {
	var docList = Folder(sourceFolder).getFiles("*.indd");
	var nDocs = docList.length;
	if (nDocs == 0) {
		alert ("Le dossier slectionn ne contient pas de documents InDesign.", "Attention");
		exit();
	}
	// dsactiver l'affichage de dialogue (il peut y avoir des images et des polices manquantes)
	app.scriptPreferences.userInteractionLevel = UserInteractionLevels.neverInteract;
	var docVers;
	for (var d=0; d<nDocs; d++) {
		docVers = testVers(docList, d);
		if (docVers > 0 && docVers <= appVers) {
			try {
				app.open(File(docList[d]));
				replaceFonts();
				try {
					app.activeDocument.save();
				}
				catch (e) {
				}
				app.activeDocument.close();
			}
			catch (e) {
				probCtr++;
			}
		}
		else {
			probCtr++;
		}
	}
}

// activer l'affichage des dialogues
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// annoncer la fin de l'action
if (probCtr == 0) {
	var dlog = new Window("palette");
	dlog.size = [320,100];
	dlog.add("statictext", [80, 100, 320, 116], "Termin.");
	dlog.show();
	// une petite pause
	$.sleep(999);
	// fermer la fentre
	dlog.close();
}
else if (probCtr == 1) {
	alert ("Un document n'a pas pu tre trat.", "Attention");
}
else {
	alert ("Le nombre de documents non trats: " + probCtr, "Attention");
}


///////////////////////////////////////////////////////////////////////////////
// les deux fonctions
///////////////////////////////////////////////////////////////////////////////

function testVers(docList, d) {
	// tenter de lire le premier bout du fichier InDesign
	var t = docList[d];
	var testString = "";
	var fileIsOpen = t.open("r");
	if (fileIsOpen) {
		try {
			testString = t.read(40);
			t.close();
		}
		catch (e) {
			try {
				t.close();
			}
			catch (e) {
			}
		}
	}
	if (testString !="") {
		try {
			var pfID = testString.charCodeAt(24);
			if (pfID == 2) { // = Mac
				return testString.charCodeAt(32);
			}
			else if (pfID == 1) {  // = Win
				return testString.charCodeAt(29);
			}
			else {
				var docVers = 0;
			}
		}
		catch (e) {
			return 0;
		}
	}
	else {
		return 0;
	}
}


///////////////////////////////////////////////////////////////////////////////
	// Remplacer les polices des textes et des styles
///////////////////////////////////////////////////////////////////////////////

function replaceFonts() {
	// une rfrence au document au premier plan
	var curDoc = app.documents[0];
	
	/////////////////////////////////////////////////////////////////////////////
	// remplacer les polices des textes
	var allStories = curDoc.stories;
	var curFont;
	var curNew;
	var curOld;
	var curPair;
	var nFonts = fontsList.length;
	var nStories = allStories.length;
	var nTsr;
	var tsr;
	var tsrFonts;
	
	for (var i=0; i<nStories; i++) {
		tsr = allStories[i].textStyleRanges;
		nTsr = tsr.length;
		tsrFonts = tsr.everyItem().appliedFont;
		for (var j=nTsr-1; j>-1; j--) {
			try {
				curFont = tsrFonts[j].name;
				for (var k=0; k<nFonts; k++) {
					curPair = fontsList[k];
					curOld = curPair.split("=")[0];
					if (curFont == curOld) {
						curNew = curPair.split("=")[1];
						if (curNew != "") {
							try {
								tsr[j].appliedFont = curNew;
							}
							catch (e) {
							}
							break;
						}
					}
				}
			}
			catch (e) {
			}
		}
	}
	
	/////////////////////////////////////////////////////////////////////////////
	// remplacer les polices des styles de paragraphes
	var curStyle;
	var paraStyles = curDoc.paragraphStyles;
	var nParaStyles = paraStyles.length;
	
	for (var i=1; i<nParaStyles; i++) {
		try {
			curStyle = paraStyles[i];
			curFont = curStyle.appliedFont.name;
			for (var j=0; j<nFonts; j++) {
				curPair = fontsList[j];
				curOld = curPair.split("=")[0];
				if (curFont == curOld) {
					curNew = curPair.split("=")[1];
					try {
						curStyle.appliedFont = curNew;
					}
					catch (e) {
					}
					break;
				}
			}
		}
		catch (e) {
		}
	}
	
	/////////////////////////////////////////////////////////////////////////////
	// remplacer les polices des groupes de styles de paragraphes
	var curGroup;
	var curParaStyles;
	var nParaStyles;	
	curGroups = curDoc.paragraphStyleGroups;
	var nParaStyleGroups = curGroups.length;
	
	if (nParaStyleGroups > 0) {
		for (var g=0; g<nParaStyleGroups; g++) {
			curGroup = curGroups[g];
			curParaStyles = curGroup.allParagraphStyles;
			nParaStyles = curParaStyles.length;
			for (var i=0; i<nParaStyles; i++) {
				try {
					curFont = curParaStyles[i].appliedFont.name;
					for (var j=0; j<nFonts; j++) {
						curPair = fontsList[j];
						curOld = curPair.split("=")[0];
						if (curOld != "") {
							if (curFont == curOld) {
								try {
									curNew = curPair.split("=")[1];
									if (curNew != "") {
										curParaStyles[i].appliedFont = curNew;
									}
								}
								catch (e) {
								}
								break;
							}
						}
					}
				}
				catch (e) {
				}
			}
		}
	}
	
	/////////////////////////////////////////////////////////////////////////////
	// remplacer les polices des styles de caractres
	var charStyles = curDoc.characterStyles;
	var curF;
	var curS;
	var nCharStyles = charStyles.length;
	
	for (var i=1; i<nCharStyles; i++) {
		try {
			curStyle = charStyles[i];
			curF = curStyle.appliedFont;
			curS = curStyle.fontStyle;
			if (curS != 1851876449) {
				curFont = curF + "\t" + curS;
				for (var j=0; j<nFonts; j++) {
					curPair = fontsList[j];
					curOld = curPair.split("=")[0];
					if (curFont == curOld) {
						try {
							curNew = curPair.split("=")[1];
							if (curNew != "") {
								curStyle.appliedFont = curNew;
							}
						}
						catch (e) {
						}
						break;
					}
				}
			}
			else {
				curFont = curF;
				for (var j=0; j<nFonts; j++) {
					curPair = fontsList[j];
					curOld = curPair.split("=")[0];
					curFam = curOld.split("\t")[0];
					if (curFont == curFam) {
						try {
							curNew = curPair.split("=")[1];
							newFam = curNew.split("\t")[0];
							if (curNew != "") {
								curStyle.appliedFont = newFam;
							}
						}
						catch (e) {
						}
						break;
					}
				}
			}
		}
		catch (e) {
		}
	}
	
	/////////////////////////////////////////////////////////////////////////////
	// remplacer les polices des groupes de styles de caractres
	curGroups = curDoc.characterStyleGroups;
	var nCharStyleGroups = curGroups.length;
	if (nCharStyleGroups > 0) {
		for (var g=0; g<nCharStyleGroups; g++) {
			curGroup = curGroups[g];
			curCharStyles = curGroup.allCharacterStyles;
			nCharStyles = curCharStyles.length;
			for (var i=0; i<nCharStyles; i++) {
				try {
					curStyle = curCharStyles[i];
					curF = curStyle.appliedFont;
					curS = curStyle.fontStyle;
					if (curS != 1851876449) {
						curFont = curF + "\t" + curS;
						for (var j=0; j<nFonts; j++) {
							curPair = fontsList[j];
							curOld = curPair.split("=")[0];
							if (curFont == curOld) {
								try {
									curNew = curPair.split("=")[1];
									if (curNew != "") {
										curStyle.appliedFont = curNew;
									}
								}
								catch (e) {
								}
								break;
							}
						}
					}
					else {
						curFont = curF;
						for (var j=0; j<nFonts; j++) {
							curPair = fontsList[j];
							curOld = curPair.split("=")[0];
							curFam = curOld.split("\t")[0];
							if (curFont == curFam) {
								try {
									curNew = curPair.split("=")[1];
									newFam = curNew.split("\t")[0];
									if (curNew != "") {
										curStyle.appliedFont = newFam;
									}
								}
								catch (e) {
								}
								break;
							}
						}
					}
				}
				catch (e) {
				}
			}
		}
	}
}